/**

  Spago4Q - The Business Intelligence Free Platform

  Copyright (C) 2009 Engineering Ingegneria Informatica S.p.A.

  Spago4Q is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  Spago4Q is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago4q.dao;

import it.eng.spago.error.EMFErrorSeverity;
import it.eng.spago.error.EMFUserError;
import it.eng.spago4q.bo.EPeriodicity;
import it.eng.spago4q.metadata.S4qEPeriodicity;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.apache.log4j.Logger;
import org.hibernate.Criteria;
import org.hibernate.HibernateException;
import org.hibernate.Session;
import org.hibernate.Transaction;

public class EPeriodicityDAOHibImpl extends AbstractHibernateDAO implements
		IES4QDAO {

	private static Logger logger = Logger
			.getLogger(EPeriodicityDAOHibImpl.class);

	public boolean deleteObject(final Integer id) throws EMFUserError {
		// TODO Auto-generated method stub
		return false;
	}

	public Integer insertObject(final Object bo) throws EMFUserError {
		// TODO Auto-generated method stub
		return null;
	}

	public Object loadObjectById(final Integer id) throws EMFUserError {
		logger.debug("IN");
		EPeriodicity toReturn = null;
		Session aSession = null;
		Transaction tx = null;
		try {
			aSession = getCurrentSession();
			tx = aSession.beginTransaction();
			S4qEPeriodicity hibPeriodicity = (S4qEPeriodicity) aSession.load(
					S4qEPeriodicity.class, id);
			toReturn = toEPeriodicity(hibPeriodicity);
		} catch (HibernateException he) {
			logger.error("Error while loading the S4qEPeriodicity with id "
					+ ((id == null) ? "" : id.toString()), he);

			if (tx != null) {
				tx.rollback();
			}

			throw new EMFUserError(EMFErrorSeverity.ERROR, 101);

		} finally {
			if (aSession != null && aSession.isOpen()) {
				aSession.close();
			}
			logger.debug("OUT");
		}
		return toReturn;
	}

	public List loadObjectList(final String fieldOrder, final String typeOrder)
			throws EMFUserError {
		logger.debug("IN");
		List<EPeriodicity> toReturn = null;
		Session aSession = null;
		Transaction tx = null;
		try {
			aSession = getCurrentSession();
			tx = aSession.beginTransaction();
			toReturn = new ArrayList<EPeriodicity>();
			List<S4qEPeriodicity> toTransform = null;

			Criteria crit = aSession.createCriteria(S4qEPeriodicity.class);

			toTransform = crit.list();

			for (Iterator<S4qEPeriodicity> iterator = toTransform.iterator(); iterator
					.hasNext();) {
				S4qEPeriodicity s4qEPeriodicity = iterator.next();

				EPeriodicity aPeriodicity = toEPeriodicity(s4qEPeriodicity);

				toReturn.add(aPeriodicity);
			}

		} catch (HibernateException he) {
			logger.error("Error while loading the list of EPeriodicity", he);

			if (tx != null) {
				tx.rollback();
			}
			throw new EMFUserError(EMFErrorSeverity.ERROR, 10031);

		} finally {
			if (aSession != null && aSession.isOpen()) {
				aSession.close();
			}
			logger.debug("OUT");
		}
		return toReturn;
	}

	protected static EPeriodicity toEPeriodicity(final S4qEPeriodicity s4qEPeriodicity) {
		EPeriodicity toReturn = null;
		if (s4qEPeriodicity != null) {
			toReturn = new EPeriodicity();
			toReturn.setIdPeriodicity(s4qEPeriodicity.getIdPeriodicity());
			toReturn.setName(s4qEPeriodicity.getName());
			toReturn.setDescription(s4qEPeriodicity.getDescription());
			toReturn.setCronstring(s4qEPeriodicity.getCronstring());
		}
		return toReturn;
	}

	public void modifyObject(final Object bo) throws EMFUserError {
		// TODO Auto-generated method stub

	}

}
