package it.eng.spago4q.exporter;

import it.eng.spago4q.dao.AbstractHibernateDAO;
import it.eng.spago4q.metadata.S4qEDataSource;
import it.eng.spago4q.metadata.S4qEInterfaceField;
import it.eng.spago4q.metadata.S4qEInterfaceType;
import it.eng.spago4q.metadata.S4qEOperation;
import it.eng.spago4q.metadata.S4qEOperationField;
import it.eng.spago4q.metadata.S4qEOperationParameter;
import it.eng.spago4q.metadata.S4qEProcess;
import it.eng.spago4q.metadata.S4qEScript;
import it.eng.spago4q.metadata.S4qESourceType;
import it.eng.spago4q.testUtils.AbstractDBTestCase;

import java.util.HashSet;
import java.util.Set;

import org.hibernate.Hibernate;
import org.hibernate.Session;
import org.hibernate.Transaction;

public class OperationExporterTest extends AbstractDBTestCase{

	private static final String FLAT_FILE = "test/flatFile/s4qFlatFileDefaultCoordinator.xml";

	public OperationExporterTest(final String value) {
		super(value);
	}

	@Override
	protected String getFlatFile() {
		return FLAT_FILE;
	}

	public void testExportOperation() {
		Session session = new AbstractHibernateDAO().getCurrentSession();
		Transaction tx = session.beginTransaction();
		S4qEOperation operation = (S4qEOperation)session.get(S4qEOperation.class, 1);
		OperationExporter operationExporter = new OperationExporter();
		
		S4qEOperation operationToExport = new S4qEOperation();
		operationToExport.setName(operation.getName());
		operationToExport.setDescription(operation.getDescription());
		operationToExport.setArchive(operation.getArchive());
		
		operationToExport.setS4qEInterfaceType(operation.getS4qEInterfaceType());
		
		S4qEProcess processToExport = new S4qEProcess();

		processToExport.setName(operation.getS4qEProcess().getName());
		processToExport.setDescription(operation.getS4qEProcess().getDescription());
		processToExport.setCoordinatorClass(operation.getS4qEProcess().getCoordinatorClass());
		S4qEInterfaceType interfaceToExport = new S4qEInterfaceType();
	
		interfaceToExport.setName(operation.getS4qEInterfaceType().getName());
		
		S4qEDataSource dataSource = new S4qEDataSource();
		dataSource.setName(operation.getS4qEDataSource().getName());
		dataSource.setS4qESourceType(new S4qESourceType());
		dataSource.getS4qESourceType().setName(operation.getS4qEDataSource().getS4qESourceType().getName());
		
		Set parameters = operation.getS4qEOperationParameters();
		
		HashSet exportParameters = new HashSet();
		for (Object object : parameters) {
			exportParameters.add((S4qEOperationParameter)object);
		}
		
		Set operationFields = operation.getS4qEOperationFields();
		
		HashSet exportOperationFields = new HashSet();
		
		for (Object object : operationFields) {
			S4qEOperationField toImport = ((S4qEOperationField)object);
			Hibernate.initialize(toImport);
			S4qEScript script = null;
			if (((S4qEOperationField)object).getS4qEScript()!= null){
				script = new S4qEScript();
				script.setDescription(((S4qEOperationField)object).getS4qEScript().getDescription());
				script.setName(((S4qEOperationField)object).getS4qEScript().getName());
				script.setScriptType(((S4qEOperationField)object).getS4qEScript().getScriptType());
				script.setScript(((S4qEOperationField)object).getS4qEScript().getScript());
			}
			toImport.setS4qEScript((S4qEScript)script);
			S4qEInterfaceField interfaceField = new S4qEInterfaceField();
			interfaceField.setName("pluto");
			toImport.setS4qEInterfaceField(interfaceField);
			
			exportOperationFields.add(toImport);
		}
		
		operation.setS4qEDataSource(dataSource);
		operation.setS4qEProcess(processToExport);
		operation.setS4qEOperationParameters(exportParameters);
		operation.setS4qEOperationFields(exportOperationFields);
		operation.setS4qEInterfaceType(interfaceToExport);
		String xml = operationExporter.exportOperation(operation);
		System.out.println(xml);
		S4qEOperation operationToImport = operationExporter.importOperation(xml);
		System.out.println(operationToImport);
		
	}

}
