package it.eng.spago4q.extractors;

import it.eng.spago4q.bo.EOperation;
import it.eng.spago4q.dao.DAOFactory;
import it.eng.spago4q.dao.IES4QFKDAO;
import it.eng.spago4q.extractors.bo.GenericItemInterface;
import it.eng.spago4q.extractors.bo.InterfaceItem;
import it.eng.spago4q.extractors.script.ScriptExecutor;
import it.eng.spago4q.extractors.utilities.OperationUtil;
import it.eng.spago4q.testUtils.AbstractDBTestCase;

import java.util.List;

public class DefaultCoordinatorTest extends AbstractDBTestCase {

	private static final String FLAT_FILE = "test/flatFile/s4qFlatFileDefaultCoordinator.xml";

	public DefaultCoordinatorTest(final String value) {
		super(value);
	}

	public void testExecute() {
		try {
			ScriptExecutor scriptExecutor = new ScriptExecutor();
			
	        IES4QFKDAO operationDAO = (IES4QFKDAO) DAOFactory.getDAO("EOperationDAO");
	        EOperation operation = (EOperation)operationDAO.loadObjectById(2);
	        
	    	DomainValueCacheCreator domainValueCacheCreator = new DomainValueCacheCreator(
					operation.getInterfaceType().getId());

			List<GenericItemInterface> genericItemList = OperationUtil
					.executeOperation(operation);
			
			List<InterfaceItem> interfaceItem = MapMaker.mapping(operation,
					genericItemList, scriptExecutor, domainValueCacheCreator);
			assertEquals("Verify the number of interface Item extracted",1,interfaceItem.size());

		} catch (Exception e) {
			fail();
		}

	}

	protected String getFlatFile() {
		return FLAT_FILE;
	}

}
