package it.eng.spago4q.extractors.bo;

import it.eng.spago.base.SourceBean;
import it.eng.spago.configuration.ConfigSingleton;
import it.eng.spago.configuration.FileCreatorConfiguration;

import java.net.URL;
import java.util.ArrayList;
import java.util.List;

import junit.framework.TestCase;

public class GenericItemUtilTest extends TestCase {

	@Override
	protected void setUp() throws Exception {
		super.setUp();
		ClassLoader loader = this.getClass().getClassLoader();
		URL xmlUrl = loader.getResource("master.xml");
		System.setProperty("AF_CONFIG_FILE", xmlUrl.getPath());
		ConfigSingleton.setConfigurationCreation(new FileCreatorConfiguration(
				ConfigSingleton.getRootPath()));
	}

	public GenericItemUtilTest(final String name) {
		super(name);
	}

	public void testGenericItemListToSourceBean() {
		List<GenericItemInterface> genericItemList = new ArrayList<GenericItemInterface>();
		GenericItem g1 = new GenericItem();
		g1.setValue("prova11", "prova1");
		g1.setValue("prova12", "prova1");
		g1.setValue("prova13", "prova1");

		GenericItem g2 = new GenericItem();
		g2.setValue("prova21", "prova2");
		g2.setValue("prova22", "prova2");
		g2.setValue("prova23", "prova2");

		genericItemList.add(g1);
		genericItemList.add(g2);
		SourceBean result = null;

		try {
			result = GenericItemUtil
					.genericItemListToSourceBean(genericItemList);
		} catch (Exception e) {
			fail();
		}
		System.out.println(result.toString());
	}
	
//	public void testSourceBeanToZipFile() {
//		List<GenericItem> genericItemList = new ArrayList<GenericItem>();
//		GenericItem g1 = new GenericItem();
//		g1.setValue("prova11", "prova1");
//		g1.setValue("prova12", "prova1");
//		g1.setValue("prova13", "prova1");
//
//		GenericItem g2 = new GenericItem();
//		g2.setValue("prova21", "prova2");
//		g2.setValue("prova22", "prova2");
//		g2.setValue("prova23", "prova2");
//
//		genericItemList.add(g1);
//		genericItemList.add(g2);
//		
//		try {
//			SourceBean a = GenericItemUtil
//			.GenericItemListToSourceBean(genericItemList);
//			GenericItemUtil.sourceBeanToZipFile("deviTrovarmi.zip", a);
//			
//		} catch (SourceBeanException e) {
//			fail();
//
//		}
//		
//	}
	
}
