package it.eng.spago4q.importer;

import java.io.FileOutputStream;
import java.sql.Connection;
import java.sql.DriverManager;

import org.dbunit.database.DatabaseConfig;
import org.dbunit.database.DatabaseConnection;
import org.dbunit.database.IDatabaseConnection;
import org.dbunit.dataset.IDataSet;
import org.dbunit.dataset.xml.FlatXmlDataSet;
import org.dbunit.ext.hsqldb.HsqldbDataTypeFactory;

import it.eng.spago4q.exporter.OperationExporter;
import it.eng.spago4q.metadata.S4qEOperation;
import it.eng.spago4q.testUtils.AbstractDBTestCase;

public class EOperationImportHibImplTest extends AbstractDBTestCase {
	
	private static final String FLAT_FILE = "test/flatFile/s4qFlatFileDefaultCoordinator.xml";

	public EOperationImportHibImplTest(final String value) {
		super(value);
	}

	@Override
	protected String getFlatFile() {
		return FLAT_FILE;
	}
	
	public void test1ImportDataOWTrue() {
		try{
	String xml = "<operation>"
	  +"<name>PRJ_MANAGMENT_OPERATION</name>"
	  +"<description>Patatine fritte</description>"
	  +"<archive>false</archive>"
	  +"<process>"
	  +"<name>PRJ_EXTRACTION_PROCESS</name>"
	  +"<description></description>"
	  +"<coordinatorClass>it.eng.spago4q.extractors.DefaultCoordinator</coordinatorClass>"
	  +"</process>"
	  +"<dataSource>S4Q_DS_DATA_BASE-S4Q_DATA_BASE</dataSource>"
	  +"<interfaceType>PROJECT_MANAGEMENT</interfaceType>"
	  +"<operationParameters>"
	  +"<operationParameter>"
	  +"<name>QUERY</name>"
	  +"<value>select * FROM spago4q.DT_PROJECT_MAN; bla bla</value>"
	  +"<cript>false</cript>"
	  +"</operationParameter>"
	  +"</operationParameters>"
	  +"<operationFields>"
	  
	  +"<operationField>"
	  +"<name>PRJ</name>"
	  +"<interfaceField>PRJ</interfaceField>"
	  +"<script>PROJECT_NAME_CONVERTER</script>"
	  +"</operationField>"
	  
	  +"<operationField>"
	  +"<name>DATE bla bal</name>"
	  +"<interfaceField>DATE</interfaceField>"
	  +"<script>DATE_CONVERTER</script>"
	  +"</operationField>"
	  
	  +"<operationField>"
	  +"<name>PV pluto</name>"
	  +"<interfaceField>PV</interfaceField>"
	  +"</operationField>"
	  
	  +"<operationField>"
	  +"<name>AC</name>"
	  +"<interfaceField>AC</interfaceField>"
	  +"</operationField>"
	  
	  +"<operationField>"
	  +"<name>EV</name>"
	  +"<interfaceField>EV</interfaceField>"
	  +"</operationField>"
	  
	  +"</operationFields>"
	  +"</operation>";
	
	OperationExporter operationExporter = new OperationExporter();
	S4qEOperation opeartionToImport = operationExporter.importOperation(xml);
	EOperationImport operationImport = new EOperationImportHibImpl();
	operationImport.importData(opeartionToImport, true);
	print();
		}catch(Exception e){
			fail();
		}
	}
	
	private void print(){
		Connection jdbcConnection = null;
		try {
			Class driverClass = Class.forName("org.hsqldb.jdbcDriver");
		jdbcConnection = DriverManager.getConnection(
				"jdbc:hsqldb:mem:/spagobi","sa","");
		IDatabaseConnection connection = new DatabaseConnection(jdbcConnection);
		DatabaseConfig config = connection.getConfig();
		config.setProperty(DatabaseConfig.PROPERTY_DATATYPE_FACTORY,
				new HsqldbDataTypeFactory());
        
		// dependent tables database export: export table X and all tables that
		// have a PK which is a FK on X, in the right order for insertion
		// String[] depTableNames =
		// TablesDependencyHelper.getAllDependentTables(
		// connection, "s4q_e_operation");
		String[] depTableNames = { "s4q_e_interface_type",
				"s4q_e_interface_field", "s4q_e_source_type",
				"s4q_e_data_source", "s4q_e_periodicity", "s4q_e_process",
				"s4q_e_operation", "s4q_e_script", "s4q_e_operation_field",
				"s4q_e_operation_parameter", "s4q_e_domain_value",
				"s4q_e_data_source_parameter"};

		IDataSet depDataset = connection.createDataSet(depTableNames);
		FlatXmlDataSet.write(depDataset, new FileOutputStream(
				"test/operatore.xml"));
		} catch (Exception e) {
			fail();
		}
	}

}
