package it.eng.spago4q.importer;

import it.eng.spago4q.metadata.S4qEScript;
import it.eng.spago4q.testUtils.AbstractDBTestCase;

import java.io.File;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;

import org.dbunit.Assertion;
import org.dbunit.database.DatabaseConfig;
import org.dbunit.database.DatabaseConnection;
import org.dbunit.database.IDatabaseConnection;
import org.dbunit.dataset.IDataSet;
import org.dbunit.dataset.ITable;
import org.dbunit.dataset.xml.FlatXmlDataSet;
import org.dbunit.ext.hsqldb.HsqldbDataTypeFactory;

public class EScriptImporterHibImplTest extends AbstractDBTestCase {
	
	public EScriptImporterHibImplTest(final String value) {
		super(value);
	}

	private static final String FLAT_FILE = "test/flatFile/s4qFlatFile.xml";

	@Override
	protected String getFlatFile() {
		return FLAT_FILE;
	}
	
	public void test1ImportDataOWFalse() {
		try{
		S4qEScript script = new S4qEScript();
		script.setIdScript(10);
		script.setName("TEST SCRIPT");
		script.setDescription("script description");
		script.setScriptType("groovy");
		script.setScript("bla bla bla");
		
		EScriptImport scriptImporter = new EScriptImportHibImpl();
		scriptImporter.importData(script, false);
		
		assertScriptTables(FLAT_FILE);
		} catch(Exception e){
			fail();
		}
	}
	
	
	
//	private void print(){
//		Connection jdbcConnection = null;
//		try {
//			Class driverClass = Class.forName("org.hsqldb.jdbcDriver");
//		jdbcConnection = DriverManager.getConnection(
//				"jdbc:hsqldb:mem:/spagobi","sa","");
//		IDatabaseConnection connection = new DatabaseConnection(jdbcConnection);
//		DatabaseConfig config = connection.getConfig();
//		config.setProperty(DatabaseConfig.PROPERTY_DATATYPE_FACTORY,
//				new HsqldbDataTypeFactory());
//        
//		// dependent tables database export: export table X and all tables that
//		// have a PK which is a FK on X, in the right order for insertion
//		// String[] depTableNames =
//		// TablesDependencyHelper.getAllDependentTables(
//		// connection, "s4q_e_operation");
//		String[] depTableNames = { "S4Q_E_SCRIPT"};
//
//		IDataSet depDataset = connection.createDataSet(depTableNames);
//		FlatXmlDataSet.write(depDataset, new FileOutputStream(
//				"test/pippopluto.xml"));
//		} catch (Exception e) {
//			fail();
//		}
//	}
	
	private void assertScriptTables(final String flatFileNamePath){
		Connection jdbcConnection = null;
		try{
		// Fetch database data after executing your code
		Class driverClass = Class.forName("org.hsqldb.jdbcDriver");
		jdbcConnection = DriverManager.getConnection(
				"jdbc:hsqldb:mem:/spagobi","sa","");
		IDatabaseConnection connection = new DatabaseConnection(jdbcConnection);
		DatabaseConfig config = connection.getConfig();
		config.setProperty(DatabaseConfig.PROPERTY_DATATYPE_FACTORY,
				new HsqldbDataTypeFactory());
        IDataSet databaseDataSet = connection.createDataSet();

        // Load expected data from an XML dataset
        IDataSet expectedDataSet = new FlatXmlDataSet(new File(flatFileNamePath));
        ITable actualScriptTable = databaseDataSet.getTable("S4Q_E_SCRIPT");

        ITable expectedScriptTable = expectedDataSet.getTable("S4Q_E_SCRIPT");
        
        //        Assert actual database table match expected table
        Assertion.assertEquals(actualScriptTable, expectedScriptTable);
        
		}catch(Exception e){
			fail();
		}finally{
			if (jdbcConnection != null){
				try {
					jdbcConnection.close();
				} catch (SQLException e) {
					fail();
				}
			}
		}
		
	}

}
