/**

  Spago4Q - The Business Intelligence Free Platform

  Copyright (C) 2009 Engineering Ingegneria Informatica S.p.A.

  Spago4Q is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  Spago4Q is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago4q.dataset;

import it.eng.spago.error.EMFUserError;
import it.eng.spago.security.IEngUserProfile;
import it.eng.spagobi.commons.dao.DAOFactory;
import it.eng.spagobi.tools.dataset.common.dataproxy.JDBCDataProxy;
import it.eng.spagobi.tools.dataset.common.datareader.JDBCDataReader;
import it.eng.spagobi.tools.dataset.common.datastore.IDataStore;
import it.eng.spagobi.tools.datasource.bo.IDataSource;
import it.eng.spagobi.tools.datasource.dao.IDataSourceDAO;

import java.util.HashMap;
import java.util.List;

import org.apache.log4j.Logger;

public class S4QJavaDataSetQuery extends AbstractS4QJavaDataSet {

	private static transient Logger logger = Logger.getLogger(S4QJavaDataSetQuery.class);

	public String getValues(final IEngUserProfile profile, final HashMap map) {
	
		String DSLabel = "SpagoBI";
		String statement = "SELECT * FROM sbi_domains s;";
		String value = "";
		
		try {
			IDataSourceDAO dataSourceDAO = DAOFactory.getDataSourceDAO();
			IDataSource dataSource = dataSourceDAO.loadDataSourceByLabel(DSLabel);
			
			JDBCDataProxy dataProxy = new JDBCDataProxy(dataSource, statement);
			JDBCDataReader dataReader = new JDBCDataReader();
			
			IDataStore dataStore = null;
			dataStore = dataProxy.load(dataReader);
			value = Integer.toString(dataStore.getFieldDistinctValues(0).size());
			logger.debug("value: " + value);
			
		} catch (EMFUserError e) {
			logger.debug(e.getLocalizedMessage());
		}
		return setDataSetResult(value);
		
	}

	@Override
	public List getNamesOfProfileAttributeRequired() {
		return null;
	}	
	
}
