/**

  Spago4Q - The Business Intelligence Free Platform

  Copyright (C) 2009 Engineering Ingegneria Informatica S.p.A.

  Spago4Q is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  Spago4Q is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago4q.utilities;

import java.io.Serializable;

import it.eng.spago.base.SourceBean;
import it.eng.spago4q.dao.DAOFactory;
import it.eng.spago4q.dao.IES4QDAO;
import it.eng.spagobi.commons.constants.SpagoBIConstants;

public abstract class DetailS4Q1ObjectUtil implements Serializable{

	private static final long serialVersionUID = -2903902150223338107L;

	public void selectObject(final Integer id, final SourceBean serviceResponse)
			throws Exception {
		IES4QDAO iEObjectDAO = (IES4QDAO) DAOFactory.getDAO(getDAOName());
		Object toReturn = iEObjectDAO.loadObjectById(id);
		serviceResponse.setAttribute(getObjectName(), toReturn);

	}

	public void updateObjectFromRequest(final SourceBean serviceRequest, final Integer id)
			throws Exception {
		Object object = getObjectFromRequest(serviceRequest);
		setObjectId(object, id);
		IES4QDAO iEObjectDAO = (IES4QDAO) DAOFactory.getDAO(getDAOName());
		iEObjectDAO.modifyObject(object);
	}

	public void restoreObject(final Integer id, final SourceBean serviceRequest,
			final SourceBean serviceResponse) throws Exception {
		Object toReturn = getObjectFromRequest(serviceRequest);
		if (id != null) {
			setObjectId(toReturn, id);
		}
		serviceResponse.setAttribute(getObjectName(), toReturn);
	}

	protected abstract Object getObjectFromRequest(SourceBean serviceRequest);

	public void newObject(final SourceBean serviceRequest, final SourceBean serviceResponse)
			throws Exception {
		Object toCreate = getObjectFromRequest(serviceRequest);
		IES4QDAO iEObjectDAO = (IES4QDAO) DAOFactory.getDAO(getDAOName());
		Integer resourceId = iEObjectDAO.insertObject(toCreate);

		serviceResponse.setAttribute("ID", resourceId);
		serviceResponse.setAttribute("MESSAGE", SpagoBIConstants.DETAIL_SELECT);
		selectObject(resourceId.intValue(), serviceResponse);
	}

	protected abstract void setObjectId(Object object, Integer id);

	protected abstract String getObjectName();

	protected abstract String getDAOName();

}
